%macro qSN(data=,var=,gamma=,shape=,out=QSN);
proc iml;
	start dsn(x, shape);
    pdf = pdf("NORMAL",x);
    cdf = cdf("NORMAL", shape # x);
  	sn=2 * pdf * cdf;
	return (sn);
	finish dsn;
	
	start dsn1(x) global(shape);
	shape=shape;
    pdf = pdf("NORMAL",x);
    cdf = cdf("NORMAL", shape # x);
  	sn=2 # pdf # cdf;
	return(sn);
	finish dsn1;

	start psn(x);
	a = .M;    
	b = x;  
	call quad(t, "dsn1", a||b);
	return(t);
	finish psn;
	
	start cumulants_half_norm(n);
		n=max(n,2);
		n=int(2#ceil(n/2));
		half_n=int(n/2);
		m=0:(half_n-1);
		pi=constant('pi');
		a=sqrt(2/pi)/(gamma(m+1)#(2##m)#(2#m+1));
		signs=repeat({1 -1},half_n)[1:half_n];
		b=signs`#a;
		a=b//t(repeat(0,half_n));
		a=a[,1]//a[,2]; /*MODIFICAR*/
		coeff=repeat(a[1,],n);
		do k=2 to n;
			ind=1:(k-1);
			coeff[k,]=a[k,]-sum((ind`# coeff[ind,])#a[(k-1):1,]/k);
 		end;
		kappa=coeff`#gamma((1:n)+1);
		kappa=kappa`;
		kappa[2,]=1+kappa[2,];
		return(kappa);
		finish;

	start sncumulants(shape);
	n=4;
	nrow=nrow(shape);
	delta=shape/sqrt(1+shape##2);
	*print delta;
	n0=n;
	n = max(n, 2);
	kv=cumulants_half_norm(n);
	if (nrow(kv)>n) then do;
		kv=kv[-(n+1),];
	end;
	kv[2,]=kv[2,]-1;
	seq=1:n;
	outer=delta##seq;
	kappa=outer`#kv;
	kappa[2,]=kappa[2,]+1;
	outer1=1;
	kappa=kappa#outer1`;
	kappa[1,]=kappa[1,];
	return(kappa);
	finish sncumulants;
	
	start qsn(p, shape);
	shape=shape;
	cum = sncumulants(shape);
	maxq = sqrt(quantile("CHISQUARE", p, 1));
    minq = -sqrt(quantile("CHISQUARE", 1 - p, 1));
	g1 = cum[3]/cum[2]##(3/2);
    g2 = cum[4]/cum[2]##2;
    x = quantile("NORMAL", p);
    x = (x + (x##2 - 1) # g1/6 + x # (x##2 - 3) # g2/24 - x # 
        (2 # x##2 - 5) # g1##2/36);
    x = cum[1] + sqrt(cum[2]) # x;

	maxerr = 1;
	maxint = 1;
	do while (maxerr > 1E-6 & maxint<200);
        x1 = x - (psn(x) - p)/dsn(x, shape);
        x1 = min(x1, maxq);
        x1 = max(x1, minq);
        maxerr = max(abs(x1 - x)/(1 + abs(x)));
        x = x1;
        maxint = maxint +1;
    end;
	y=x;
	return(y);
	finish qsn;
	%if &data= %then %do;
	shape=&shape;
	qsn=qsn(&gamma, shape[1]);
	print shape qsn;
	%end;
	%else %do;
	use &data;read all var{&var} into shapef;
	qsn =j(nrow(shapef),1,0);
	do i=1 to nrow(shapef);
	shape=shapef[i];
	qsn [i]=qsn(&gamma, shape[1]);
	end;
	%end;
create &out var{qsn};
append;
quit;
%mend qSN;

%qSN(gamma=0.975,shape=0);
%qSN(gamma=0.025,shape=0);
%qSN(gamma=0.975,shape=2);
%qSN(gamma=0.025,shape=2);
%qSN(gamma=0.975,shape=-2);
%qSN(gamma=0.025,shape=-2);
%qSN(gamma=0.975,shape=5);
%qSN(gamma=0.025,shape=5);


%macro qST(data=,var=,gamma=,shape=,df=,out=QST);
proc iml;
	start dst(x, shape, df);
    pdf = pdf("T",x, df);
    cdf = cdf("T", shape # x # sqrt((df + 1)/(x##2 + df)), df + 1);
  	st=2 * pdf * cdf;
	return (st);
	finish dst;
	
	start dst1(x) global(shape, df);
    pdf = pdf("T",x, df);
    cdf = cdf("T", shape # x # sqrt((df + 1)/(x##2 + df)), df + 1);
  	st=2 # pdf # cdf;
	return(st);
	finish dst1;

	start pst(x);
	a = .M;    
	b = x;  
	call quad(t, "dst1", a||b);
	return(t);
	finish pst;

	start stcumulants(shape, df1);
	df=max(5,df1);
	n=4; 
	pi=constant("pi");
	n = min(n, 4);
	par =shape;
	nrow=nrow(par);

	delta=shape/sqrt(1+shape##2);
	mu=delta#sqrt(df/pi)#exp(log(gamma((df - 1)/2)) - log(gamma(df/2)));
	cum = J(nrow, n,0);
	cum[, 1] = mu;

	if n > 1 then do; 
        cum[, 2] = df/(df - 2) - mu##2;
	end;
    else; if n > 2 then do; 
        cum[, 3] = mu#(df#(3 - delta##2)/(df - 3) - 3#df/(df - 2) + 2# mu##2);
	end;
    else; if n > 3 then do;
        cum[, 4] = (3# df##2/((df - 2)#(df - 4)) - 4#mu##2 # 
            df # (3 - delta##2)/(df - 3) + 6 # mu##2 # df/(df - 
            2) - 3 # mu##4) - 3 # cum[, 2]##2;
	end;
	
	seq=1:n;
	outer=1;
	cum = cum # outer;
	cum[, 1] = cum[, 1];
	return(cum);
	finish;
	
	start qst(p, shape, df);
	cum = stcumulants(shape,df);
	maxq = sqrt(quantile("F", p, 1, 1));
    minq = -sqrt(quantile("F", 1 - p, 1, 1));
	g1 = cum[3]/cum[2]##(3/2);
    g2 = cum[4]/cum[2]##2;
    x = quantile("NORMAL", p);
    x = (x + (x##2 - 1) # g1/6 + x # (x##2 - 3) # g2/24 - x # 
        (2 # x##2 - 5) # g1##2/36);
    x = cum[,1] + sqrt(cum[,2]) # x;

	maxerr = 1;
	maxint = 1;
	do while (maxerr > 1E-6 & maxint<200);
        x1 = x - (pst(x) - p)/dst(x, shape, df);
        x1 = min(x1, maxq);
        x1 = max(x1, minq);
        maxerr = max(abs(x1 - x)/(1 + abs(x)));
        x = x1;
        maxint = maxint +1;
    end;
	y=x;
	return(y);
	finish qst;
	df=&df;
	%if &data= %then %do;
	shape=&shape;
	qst=qst(&gamma,shape[1],df[1]);
	print shape df qst;
	%end;
	%else %do;
	use &data;read all var{&var} into shapef;
	qst =j(nrow(shapef),1,0);
	do i=1 to nrow(shapef);
	shape=shapef[i];
	qst[i]=qst(&gamma,shape[1],df[1]);
	end;
	%end;
create &out var{qst};
append;
quit;
%mend qST;

%qST(gamma=0.975,shape=0,df=200);
%qST(gamma=0.025,shape=0,df=200);
%qST(gamma=0.975,shape=2,df=200);
%qST(gamma=0.025,shape=2,df=200);
%qST(gamma=0.975,shape=0,df=10);
%qST(gamma=0.025,shape=0,df=10);
%qST(gamma=0.975,shape=-2,df=10);
%qST(gamma=0.025,shape=-2,df=10);


%macro SN(n=,seed1=123,seed2=4321,shape=0,mean=0,var=1,out=SN);
data &out;
   do i = 1 to &n;
		mu_0=rannor(&seed1);
		v=rannor(&seed2);
		output;
   end;
 run;

data &out;set &out;
delta=&shape/sqrt(1+(&shape)**2);
mu_1 = delta* mu_0 + v* sqrt(1- delta**2 ) ;
if mu_0>=0 then z = mu_1;
		   else z= - mu_1; 
lambda= delta/ sqrt(1- delta**2);
y= &mean + sqrt(&var)*z ;
run;
quit;
proc gchart data=&out;
vbar z /space=0 raxis=axis1;
axis1 label=(a=90);
run;quit;
proc gchart data=&out;
vbar y /space=0 raxis=axis1;
axis1 label=(a=90);
run;quit;
%mend SN;

%SN(n=10000);
proc means data=SN mean var;var z y;run;
proc sort data=sn;by z;run;
data sn;set sn;prob=1/10000;
cum+prob;
if round(cum,0.0001) in (0.0250 0.9750);
put z;
run;
%SN(n=10000, shape=-2);
data _null_;
mu=0;
sigma2=1;
shape=-2;
delta=shape/sqrt(1+shape**2);
mu_sn=mu+sqrt(sigma2)*delta*sqrt(2/3.14159);
sigma2_sn=sigma2*(1-2*delta**2/3.14159);
put mu_sn sigma2_sn;
put mu;
run;
proc means data=SN mean var;var z y;run;
proc sort data=sn;by z;run;
data sn;set sn;prob=1/10000;
cum+prob;
if round(cum,0.0001) in (0.0250 0.9750);
put z;
run;

%SN(n=10000, shape =2);
data _null_;
mu=0;
sigma2=1;
shape=2;
delta=shape/sqrt(1+shape**2);
mu_sn=mu+sqrt(sigma2)*delta*sqrt(2/3.14159);
sigma2_sn=sigma2*(1-2*delta**2/3.14159);
put mu_sn sigma2_sn;
put mu;
run;
proc means data=SN mean var;var z y;run;
proc sort data=sn;by z;run;
data sn;set sn;prob=1/10000;
cum+prob;
if round(cum,0.0001) in (0.0250 0.9750);
put z;
run;

%SN(n=10000, shape =-5);
data _null_;
mu=0;
sigma2=1;
shape=5;
delta=shape/sqrt(1+shape**2);
mu_sn=mu+sqrt(sigma2)*delta*sqrt(2/3.14159);
sigma2_sn=sigma2*(1-2*delta**2/3.14159);
put mu_sn sigma2_sn;
put mu;
run;
proc means data=SN mean var;var z y;run;
proc sort data=sn;by z;run;
data sn;set sn;prob=1/10000;
cum+prob;
if round(cum,0.0001) in (0.0250 0.9750);
put z;
run;

%SN(n=10000, shape =5, mean=10, var=5);
data _null_;
mu=10;
sigma2=5;
shape=5;
delta=shape/sqrt(1+shape**2);
mu_sn=mu+sqrt(sigma2)*delta*sqrt(2/3.14159);
sigma2_sn=sigma2*(1-2*delta**2/3.14159);
put mu_sn sigma2_sn;
put mu;
run;
proc means data=SN mean var;var z y;run;


%macro ST(n=,seed1=123,seed2=321,shape=0,df=200,mean=0,var=1,out=ST);
data &out;
   call streaminit(&seed1);
   do i = 1 to &n;
   		mu_0=rannor(&seed1);
		v=rannor(&seed2);
		w=RAND('CHISQUARE',&df);
		output;
   end;
 run;

data &out;set &out;
df=&df;
delta=&shape/sqrt(1+(&shape)**2);
mu_1 = delta* mu_0 + v* sqrt(1- delta**2 ) ;
if mu_0>=0 then z = mu_1;
		   else z= - mu_1; 
lambda= delta/ sqrt(1- delta**2);
y= &mean + sqrt(&var)*z ;
W=y/sqrt(W/df);
run;
quit;
proc gchart data=&out;
vbar W /space=0 raxis=axis1;
axis1 label=(a=90);
run;quit;
%mend ST;

%ST(n=10000, shape =0, df=10);
proc sort data=st;by z;run;
data st;set st;prob=1/10000;
cum+prob;
if round(cum,0.0001) in (0.0250 0.9750);
put w;
run;
%ST(n=10000, shape =-2, df=10);
proc sort data=st;by z;run;
data st;set st;prob=1/10000;
cum+prob;
if round(cum,0.0001) in (0.0250 0.9750);
put w;
run;
%ST(n=10000, shape =0, df=200);
proc sort data=st;by z;run;
data st;set st;prob=1/10000;
cum+prob;
if round(cum,0.0001) in (0.0250 0.9750);
put w;
run;
%ST(n=10000, shape =-2, df=200);
proc sort data=st;by z;run;
data st;set st;prob=1/10000;
cum+prob;
if round(cum,0.0001) in (0.0250 0.9750);
put w;
run;

